%% Generation of UWB Signals

close all
clear all
clc

%% Exercise 1 - Pulse Shape Generator

fc  = 1e11;  % Sampling Frequency [Hz]
Tm  = 0.9e-9; % Pulse Duration [s]
tau = 0.2e-9;  % Shape Factor

p1 = gaussian_wf(fc,Tm,tau,1); % First Derivative
p2 = gaussian_wf(fc,Tm,tau,2); % Second Derivative

time = linspace(-Tm/2,Tm/2, length(p1));
figure()
plot(time,p1)
hold all
plot(time,p2)
grid on
legend('Monocycle','Doublet')
xlabel('Time [s]');
ylabel('Amplitude');
% pause;

%%
% Inputs for Exercises 2 and 3
numbits  = 2;       % bitstream length
Ns = 3;             % channel coder repetition factor
Np = 3;             % Time Hopping code length
Nh = 3;             % code max value
Tc = 1e-9;          % Chip time
Ts = 5e-9;          % frame time
dPPM = 0.2e-9;      % PPM shift
powdBm = -30;       % avg Tx Power [dBm]

%% Exercise 2 - Checkpoint 2-1 - 2PPM-TH Generation
[data_PPM_TH, c, signal_PPM_TH, TH_signal] = TX_BPPM_TH(numbits,Ns,fc,Tc,Ts,Np,Nh,dPPM,Tm,tau,powdBm);
% pause;

%% Exercise 3 - Checkpoint 2-2 - 2PAM-DS Generation 
[data_PAM_DS, ac, signal_PAM_DS, DS_signal] = TX_BPAM_DS(numbits,Ns,fc,Ts,Np,Nh,Tm,tau,powdBm);